#pragma once

// Object names for PSO editor objects (rgPipelineStateModelVulkan.cpp) - START
// String constants.
static const char* STR_ALPHA_BLEND_OP_NODE = "pAlphaBlendOpNode";
static const char* STR_ALPHA_BLEND_TO_COVERAGE_NODE = "pAlphaToCoverageNode";
static const char* STR_ALPHA_TO_ONE_NODE = "pAlphaToOneNode";
static const char* STR_ARRAY_ELEMENT = "pArrayElement";
static const char* STR_ATTACHMENT_COUNT_ITEM = "pAttachmentCountItem";
static const char* STR_ATTACHMENT_NODE = "pAttachmentNode";
static const char* STR_ATTACHMENTS_ROOT_ITEM = "pAttachmentsRootItem";
static const char* STR_BACK_STENCIL_OP_STATE_NODE = "pBackStencilOpStateNode";
static const char* STR_BASE_PIPELINE_INDEX_CREATE_INFO = "pBasePipelineIndexCreateInfo";
static const char* STR_BINDING_ELEMENT = "pBindingElement";
static const char* STR_BLEND_CONSTANT_NODE = "pBlendConstantNode";
static const char* STR_BLEND_CONSTANTS_ROOT_NODE = "pBlendConstantsRootNode";
static const char* STR_BLEND_ENABLE_NODE = "pBlendEnableNode";
static const char* STR_COLOR_ATTACHMENT_COUNT_NODE = "pColorAttachmentCountNode";
static const char* STR_COLOR_ATTACHMENTS_ROOT_ITEM = "pColorAttachmentsRootItem";
static const char* STR_COLOR_BLEND_ATTACHEMENT_STATE_COUNT_ITEM = "pColorBlendAttachmentStateCountItem";
static const char* STR_COLOR_BLEND_OP_NODE = "pColorBlendOpNode";
static const char* STR_COLOR_BLEND_STATE_ROOT = "pColorBlendStateRoot";
static const char* STR_COMPARE_MASK_NODE = "pCompareMaskNode";
static const char* STR_COMPARE_OP_NODE = "pCompareOpNode";
static const char* STR_COLOR_COMPONENT_WRITE_MASK = "pColorComponentWriteMask";
static const char* STR_CREATE_INFO_ROOT_NODE = "pCreateInfoRootNode";
static const char* STR_CULL_MODE_NODE = "pCullModeNode";
static const char* STR_DEPENDENCIES_ROOT_ITEM = "pDependenciesRootItem";
static const char* STR_DEPENDENCY_DESCRIPTION_COUNT_ITEM = "pDependencyDescriptionCountItem";
static const char* STR_DEPENDENCY_FLAGS = "pDependencyFlags";
static const char* STR_DEPTH_BIAS_CLAMP_NODE = "pDepthBiasClampNode";
static const char* STR_DEPTH_BIAS_CONSTANT_FACTOR_NODE = "pDepthBiasConstantFactorNode";
static const char* STR_DEPTH_BIAS_ENABLE_NODE = "pDepthBiasEnableNode";
static const char* STR_DEPTH_BIAS_SLOPE_FACTOR_NODE = "pDepthBiasSlopeFactorNode";
static const char* STR_DEPTH_BOUNDS_TEST_ENABLE_NODE = "pDepthBoundsTestEnableNode";
static const char* STR_DEPTH_CLAMP_ENABLE_ITEM = "pDepthClampEnableItem";
static const char* STR_DEPTH_COMPARE_OP_NODE = "pDepthCompareOpNode";
static const char* STR_DEPTH_FAIL_OP = "pDepthFailOp";
static const char* STR_DEPTH_STENCIL_ATTACHMENTS_ROOT_ITEM = "pDepthStencilAttachmentsRootItem";
static const char* STR_DEPTH_STENCIL_STATE_ROOT = "pDepthStencilStateRoot";
static const char* STR_DEPTH_TEST_ENABLE_NODE = "pDepthTestEnableNode";
static const char* STR_DEPTH_WRITE_ENABLE_NODE = "pDepthWriteEnableNode";
static const char* STR_DESCRIPTOR_SET_BINDING_COUNT_ITEM = "pDescriptorSetBindingCountItem";
static const char* STR_DESCRIPTION_SET_LAYOUT_BINDING_COUNT_NODE = "pDescriptorSetLayoutBindingCountNode";
static const char* STR_DESCRIPTOR_SET_LAYOUT_BINDING_INDEX_NODE = "pDescriptorSetLayoutBindingIndexNode";
static const char* STR_DESCRIPTOR_SET_LAYOUT_BINDINGS_ROOT_ITEM = "pDescriptorSetLayoutBindingsRootItem";
static const char* STR_DESCRIPTOR_SET_LAYOUT_COUNT_ITEM = "pDescriptorSetLayoutCountItem";
static const char* STR_DESCRIPTOR_SET_LAYOUT_FLAGS_NODE = "pDescriptorSetLayoutFlagsNode";
static const char* STR_DESCRIPTOR_SET_LAYOUT_HANDLE_NODE = "pDescriptorSetLayoutHandleNode";
static const char* STR_DESCRIPTOR_SET_LAYOUTS_ITEM = "pDescriptorSetLayoutsItem";
static const char* STR_DESCRIPTOR_SET_LAYOUTS_ROOT = "pDescriptorSetLayoutsRoot";
static const char* STR_DESCRIPTOR_SET_LAYOUTS_ROOT_ITEM = "pDescriptorSetLayoutsRootItem";
static const char* STR_DESCRIPTOR_TYPE_NODE = "pDescriptorTypeNode";
static const char* STR_DST_ACCESS_MASK = "pDstAccessMask";
static const char* STR_DST_ALPHA_BLEND_FACTOR_NODE= "pDstAlphaBlendFactorNode";
static const char* STR_DST_COLOR_BLEND_FACTOR_NODE = "pDstColorBlendFactorNode";
static const char* STR_DST_STAGE_MASK = "pDstStageMask";
static const char* STR_DST_SUBPASS = "pDstSubpass";
static const char* STR_EXTENT_ROOT= "pExtentRoot";
static const char* STR_FAIL_OP_NODE = "pFailOpNode";
static const char* STR_FINAL_LAYOUT_ITEM = "pFinalLayoutItem";
static const char* STR_FLAGS = "pFlags";
static const char* STR_FLAGS_ELEMENT = "pFlagsElement";
static const char* STR_FLAGS_ITEM = "pFlagsItem";
static const char* STR_FORMAT_ELEMENT = "pFormatElement";
static const char* STR_FRONT_FACE_NODE = "pFrontFaceNode";
static const char* STR_FRONT_STENCIL_OP_STATE_NODE = "pFrontStencilOpStateNode";
static const char* STR_GRAPHICS_PIPELINE_CREATE_INFO_ROOT = "pGraphicsPipelineCreateInfoRoot";
static const char* STR_HEIGHT_ITEM = "pHeightItem";
static const char* STR_INITIAL_LAYOUT_ITEM = "pIinitialLayoutItem";
static const char* STR_IMAGE_LAYOUT_NODE = "pImageLayoutNode";
static const char* STR_INPUT_ASSEMBLY_STATE_ROOT = "pInputAssemblyStateRoot";
static const char* STR_INPUT_ATTACHMENT_COUNT_NODE = "pInputAttachmentCountNode";
static const char* STR_INPUT_ATTACHMENTS_ROOT_ITEM = "pInputAttachmentsRootItem";
static const char* STR_INPUT_RATE_ELEMENT = "pInputRateElement";
static const char* STR_LINE_WIDTH_NODE = "pLineWidthNode";
static const char* STR_LOAD_OP_ITEM = "pLoadOpItem";
static const char* STR_LOCATION_ELEMENT = "pLocationElement";
static const char* STR_LOGIC_OP_ENABLE_NODE = "pLogicOpEnableNode";
static const char* STR_LOGIC_OP_NODE = "pLogicOpNode";
static const char* STR_MAX_DEPTH_BOUNDS_NODE= "pMaxDepthBoundsNode";
static const char* STR_MAX_DEPTH_ITEM = "pMaxDepthItem";
static const char* STR_MIN_DEPTH_BOUNDS_NODE = "pMinDepthBoundsNode";
static const char* STR_MIN_DEPTH_ITEM = "pMinDepthItem";
static const char* STR_MIN_SAMPLE_SHADING_NODE = "pMinSampleShadingNode";
static const char* STR_MULTISAMPLE_STATE_ROOT = "pMultisampleStateRoot";
static const char* STR_OFFSET_ELEMENT = "pOffsetElement";
static const char* STR_OFFSET_NODE = "pOffsetNode";
static const char* STR_PASS_OP_NODE = "pPassOpNode";
static const char* STR_PATCH_CONTROL_POINTS_ITEM = "pPatchControlPointsItem";
static const char* STR_PIPELINE_BIND_POINT_NODE = "pPipelineBindPointNode";
static const char* STR_PIPELINE_LAYOUT_CREATE_INFO_ROOT = "pPipelineLayoutCreateInfoRoot";
static const char* STR_POLYGON_MODE_NODE = "pPolygonModeNode";
static const char* STR_PRESERVE_ATTACHMENT_COUNT_NODE = "pPreserveAttachmentCountNode";
static const char* STR_PRESERVE_ATTACHMENT_NODE = "pPreserveAttachmentNode";
static const char* STR_PRESERVE_INPUT_ATTACHMENT_ROOT_ITEM = "pPreserveInputAttachmentsRootItem";
static const char* STR_PRIMITIVE_RESTART_ENABLE_ITEM = "pPrimitiveRestartEnableItem";
static const char* STR_PUSH_CONSTANT_ARRAY_ROOT_ITEM = "pPushConstantsArrayRootItem";
static const char* STR_PUSH_CONSTANTS_COUNT_ITEM = "pPushConstantsCountItem";
static const char* STR_RASTERIZATION_SAMPLES = "pRasterizationSamples";
static const char* STR_RASTERIZATION_STATE_ROOT= "pRasterizationStateRoot";
static const char* STR_RASTERIZER_DISCARD_ENABLE = "pRasterizerDiscardEnable";
static const char* STR_REFERENCE_NODE = "pReferenceNode";
static const char* STR_RENDER_PASS_CREATE_INFO_ROOT = "pRenderPassCreateInfoRoot";
static const char* STR_RESOLVE_ATTACHMENT_COUNT_NODE = "pResolveAttachmentCountNode";
static const char* STR_RESOLVE_ATTACHMENTS_ROOT_ITEM = "pResolveAttachmentsRootItem";
static const char* STR_SAMPLE_MASK_COUNT_NODE = "pSampleMaskCountNode";
static const char* STR_SAMPLE_MASK_ELEMENT_NODE = "pSampleMaskElementNode";
static const char* STR_SAMPLE_MASK_ROOT_ITEM = "pSampleMaskRootItem";
static const char* STR_SAMPLE_SHADING_ENABLE = "pSampleShadingEnable";
static const char* STR_SAMPLES_ITEM = "pSamplesItem";
static const char* STR_SCISSOR_COUNT_ITEM = "pScissorCountItem";
static const char* STR_SCISSORS_ROOT_ITEM = "pScissorsRootItem";
static const char* STR_SIZE_NODE = "pSizeNode";
static const char* STR_SRC_ACCESS_MASK = "pSrcAccessMask";
static const char* STR_SRC_ALPHA_BLEND_FACTOR_NODE = "pSrcAlphaBlendFactorNode";
static const char* STR_SRC_COLOR_BLEND_FACTOR_NODE = "pSrcColorBlendFactorNode";
static const char* STR_SRC_STAGE_MASK = "pSrcStageMask";
static const char* STR_SRC_SUBPASS = "pSrcSubpass";
static const char* STR_STAGE_FLAGS_NODE = "pStageFlagsNode";
static const char* STR_STENCIL_LOAD_OP_ITEM = "pStencilLoadOpItem";
static const char* STR_STENCIL_STORE_OP_ITEM = "pStencilStoreOpItem";
static const char* STR_STENCIL_TEST_ENABLE_NODE = "pStencilTestEnableNode";
static const char* STR_STORE_OP_ITEM = "pStoreOpItem";
static const char* STR_STRIDE_ELEMENT = "pStrideElement";
static const char* STR_SUBPASS_DESCRIPTION_COUNT_ITEM = "pSubpassDescriptionCountItem";
static const char* STR_SUBPASS_ROOT_ITEM = "pSubpassRootItem";
static const char* STR_TESSELLATION_STATE_ROOT = "pTessellationStateRoot";
static const char* STR_TOPOLOGY_ITEM= "pTopologyItem";
static const char* STR_VERTEX_ATTRIBUTE_DESCRIPTION_COUNT_ITEM = "pVertexAttributeDescriptionCountItem";
static const char* STR_VERTEX_ATTRIBUTE_DESCRIPTIONS_ITEM = "pVertexAttributeDescriptionsItem";
static const char* STR_VERTEX_BINDING_DESCRIPTION_COUNT_ITEM = "pVertexBindingDescriptionCountItem";
static const char* STR_VERTEX_BINDING_DESCRIPTIONS_ITEM = "pVertexBindingDescriptionsItem";
static const char* STR_VERTEX_INPUT_STATE_ROOT = "pVertexInputStateRoot";
static const char* STR_VIEWPORT_COUNT_ITEM = "pViewportCountItem";
static const char* STR_VIEWPORT_STATE_ROOT_ITEM = "pViewportStateRoot";
static const char* STR_VIEWPORTS_ROOT_ITEM = "pViewportsRootItem";
static const char* STR_VK_COMPUTE_PIPELINE_CREATE_INFO_ROOT = "pVkComputePipelineCreateInfoRoot";
static const char* STR_WIDTH_ITEM = "pWidthItem";
static const char* STR_WRITE_MASK_NODE = "pWriteMaskNode";
static const char* STR_X_ITEM = "pXItem";
static const char* STR_Y_ITEM = "pYItem";
// Object names for PSO editor objects (rgPipelineStateModelVulkan.cpp) - END